/*
  KeePT - Plugin for KeePass 1.21
  Copyright (C) 2010 Nikolaus Hammler <niki@hammler.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef _WIN32_WINNT
#define _WIN32_WINNT  0x0500
#endif

#include "KeePassLibCpp/SDK/KpSDK.h"

#include "resource.h"

#define MENUITEMCOUNT				1

// title for MessageBox
#define MSGTITLE					_T("KeePass KeePT plugin")

// keys for KeePass.ini
#define CONF_WPTPATH				_T("KeePT_WinPT_Path")
#define CONF_WPTCLOSE				_T("KeePT_Close")
#define CONF_WPTHKEY				_T("KeePT_Hotkeys")
#define CONF_WPTUSEPORTABLE			_T("KeePT_UsePortable")
// default config settings
#define CONF_WPTCLOSE_DEF			TRUE
#define CONF_WPTUSEPORTABLE_DEF		FALSE
#define CONF_WPTHKEY_DEF			FALSE


#define WM_HKEYCNTRL_GUID	_T("F4AD85FC-CE47-42d9-82B6-C6191B8EC1FC")

void KeePTSettings();

class KeePTPlugin : public IKpPlugin
{
public:
	KeePTPlugin();
	~KeePTPlugin();

	KP_DECL_IUNKNOWN;

	STDMETHODIMP_(BOOL) OnMessage(DWORD dwCode, LPARAM lParamW, LPARAM lParamL);

	STDMETHODIMP_(LPCTSTR) GetProperty(LPCTSTR lpName);
	STDMETHODIMP SetProperty(LPCTSTR lpName, LPCTSTR lpValue);

	STDMETHODIMP_(DWORD) GetMenuItemCount();
	STDMETHODIMP_(KP_MENU_ITEM*) GetMenuItems();

private:

	KP_DECL_STDREFIMPL;

	KP_MENU_ITEM m_menuItems[MENUITEMCOUNT];
};
