/*
  KeePT - Plugin for KeePass 1.21
  Copyright (C) 2010 Nikolaus Hammler <niki@hammler.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef __WINPTINJECTOR_H__
#define __WINPTINJECTOR_H__

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "apihijack.h"

typedef int (WINAPI *DialogBoxParam_Type)(HINSTANCE, LPCTSTR, HWND, DLGPROC, LPARAM);

int WINAPI MyDialogBoxParam(HINSTANCE hInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam);

bool InjectPT(HINSTANCE hModule);

#define WINPT_KEYID_MAXLEN	17

// from wptGPG.h ...
struct passphrase_cb_s {
    int gpg_cmd;	/* sign or decrypt. */
    int pwd_init;	/* 1 = passphrase request via dialog. */
    char *pwd;		/* actual passphrase. */
    char info[1024];	/* hold up the info message */
    char *title;	/* dialog title. */
    char keyid[WINPT_KEYID_MAXLEN];	/* keyid of the secret key the pwd can be used for. */
    HWND hwnd;		/* handle of the dialog window. */
    int cancel;		/* 1 = user cancelled passphrase request. */
    unsigned int is_card:1; /* 1 = key stored on a smart card. */
    unsigned int bad_pwd:1; /* 1 = last passphrase was bad. */
    void *gpg;
    void *recipients;
    struct {
	int sym_algo;
	int s2k_mode;
	int s2k_hash;
    } sym;
}; 

// from wptGPG.h
enum gpg_cmd_t {
    GPG_CMD_DECRYPT = 0,
    GPG_CMD_SIGN    = 1
};

#endif

